ServletRequest (Servlet 6.1 API Documentation - Apache Tomcat 11.0.5)
Description: declaration: package: jakarta.servlet, interface: ServletRequest

# Interface ServletRequest

All Known Subinterfaces:
  `HttpServletRequest`

All Known Implementing Classes:
  `HttpServletRequestWrapper`, `ServletRequestWrapper`

public interface ServletRequest
Defines an object to provide client request information to a servlet. The servlet container creates a `ServletRequest` object and passes it as an argument to the servlet's `service` method.

A `ServletRequest` object provides data including parameter name and values, attributes, and an input stream. Interfaces that extend `ServletRequest` can provide additional protocol-specific data (for example, HTTP data is provided by `HttpServletRequest`.

See Also:
  - `HttpServletRequest`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AsyncContext`
  `getAsyncContext()`
  Get the current AsyncContext.
  `Object`
  `getAttribute(String name)`
  Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.
  `Enumeration<String>`
  `getAttributeNames()`
  Returns an `Enumeration` containing the names of the attributes available to this request.
  `String`
  `getCharacterEncoding()`
  Returns the name of the character encoding used in the body of this request.
  `int`
  `getContentLength()`
  Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
  `long`
  `getContentLengthLong()`
  Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
  `String`
  `getContentType()`
  Returns the MIME type of the body of the request, or `null` if the type is not known.
  `DispatcherType`
  `getDispatcherType()`
  `ServletInputStream`
  `getInputStream()`
  Retrieves the body of the request as binary data using a `ServletInputStream`.
  `String`
  `getLocalAddr()`
  Returns the Internet Protocol (IP) address of the interface on which the request was received.
  `Locale`
  `getLocale()`
  Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header.
  `Enumeration<Locale>`
  `getLocales()`
  Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.
  `String`
  `getLocalName()`
  Returns the host name of the Internet Protocol (IP) interface on which the request was received.
  `int`
  `getLocalPort()`
  Returns the Internet Protocol (IP) port number of the interface on which the request was received.
  `String`
  `getParameter(String name)`
  Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist.
  `Map<String,String[]>`
  `getParameterMap()`
  Returns a java.util.Map of the parameters of this request.
  `Enumeration<String>`
  `getParameterNames()`
  Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request.
  `String[]`
  `getParameterValues(String name)`
  Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.
  `String`
  `getProtocol()`
  Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1.
  `String`
  `getProtocolRequestId()`
  Obtain the request identifier for this request as defined by the protocol in use.
  `BufferedReader`
  `getReader()`
  Retrieves the body of the request as character data using a `BufferedReader`.
  `String`
  `getRemoteAddr()`
  Returns the Internet Protocol (IP) address of the client or last proxy that sent the request.
  `String`
  `getRemoteHost()`
  Returns the fully qualified name of the client or the last proxy that sent the request.
  `int`
  `getRemotePort()`
  Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.
  `RequestDispatcher`
  `getRequestDispatcher(String path)`
  Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
  `String`
  `getRequestId()`
  Obtain a unique (within the lifetime of the Servlet container) identifier string for this request.
  `String`
  `getScheme()`
  Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`.
  `String`
  `getServerName()`
  Returns the host name of the server to which the request was sent.
  `int`
  `getServerPort()`
  Returns the port number to which the request was sent.
  `ServletConnection`
  `getServletConnection()`
  Obtain details of the network connection to the Servlet container that is being used by this request.
  `ServletContext`
  `getServletContext()`
  `boolean`
  `isAsyncStarted()`
  `boolean`
  `isAsyncSupported()`
  `boolean`
  `isSecure()`
  Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
  `void`
  `removeAttribute(String name)`
  Removes an attribute from this request.
  `void`
  `setAttribute(String name, Object o)`
  Stores an attribute in this request.
  `void`
  `setCharacterEncoding(String encoding)`
  Overrides the name of the character encoding used in the body of this request.
  `default void`
  `setCharacterEncoding(Charset encoding)`
  Overrides the character encoding used in the body of this request.
  `AsyncContext`
  `startAsync()`
  `AsyncContext`
  `startAsync(ServletRequest servletRequest, ServletResponse servletResponse)`

- ## Method Details

  - ### getAttribute

    Object getAttribute(String name)
    Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.

    Attributes can be set two ways. The servlet container may set attributes to make available custom information about a request. For example, for requests made using HTTPS, the attribute `jakarta.servlet.request.X509Certificate` can be used to retrieve information on the certificate of the client. Attributes can also be set programmatically using `setAttribute(java.lang.String, java.lang.Object)`. This allows information to be embedded into a request before a `RequestDispatcher` call.

    Attribute names should follow the same conventions as package names. Names beginning with `jakarta.*` are reserved for use by the Jakarta EE platform.

    Parameters:
      `name` - a `String` specifying the name of the attribute
    Returns:
      an `Object` containing the value of the attribute, or `null` if the attribute does not exist

  - ### getAttributeNames

    Enumeration<String> getAttributeNames()
    Returns an `Enumeration` containing the names of the attributes available to this request. This method returns an empty `Enumeration` if the request has no attributes available to it.
    Returns:
      an `Enumeration` of strings containing the names of the request's attributes

  - ### getCharacterEncoding

    String getCharacterEncoding()
    Returns the name of the character encoding used in the body of this request. This method returns `null` if the no character encoding has been specified. The following priority order is used to determine the specified encoding:
    1. per request
    2. web application default via the deployment descriptor or `ServletContext.setRequestCharacterEncoding(String)`
    3. container default via container specific configuration
    Returns:
      a `String` containing the name of the character encoding, or `null` if the request does not specify a character encoding

  - ### setCharacterEncoding

    void setCharacterEncoding(String encoding) throws UnsupportedEncodingException
    Overrides the name of the character encoding used in the body of this request. This method must be called prior to reading request parameters or reading input using getReader().
    Parameters:
      `encoding` - a `String` containing the name of the character encoding
    Throws:
      `UnsupportedEncodingException` - if this is not a valid encoding

  - ### setCharacterEncoding

    default void setCharacterEncoding(Charset encoding)
    Overrides the character encoding used in the body of this request. This method must be called prior to reading request parameters or reading input using getReader(). Otherwise, it has no effect.

    Implementations are strongly encouraged to override this default method and provide a more efficient implementation.

    Parameters:
      `encoding` - `Charset` representing the character encoding.
    Since:
      Servlet 6.1

  - ### getContentLength

    int getContentLength()
    Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.
    Returns:
      an integer containing the length of the request body or -1 if the length is not known or is greater than `Integer.MAX_VALUE`

  - ### getContentLengthLong

    long getContentLengthLong()
    Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.
    Returns:
      a long integer containing the length of the request body or -1 if the length is not known
    Since:
      Servlet 3.1

  - ### getContentType

    String getContentType()
    Returns the MIME type of the body of the request, or `null` if the type is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_TYPE.
    Returns:
      a `String` containing the name of the MIME type of the request, or null if the type is not known

  - ### getInputStream

    ServletInputStream getInputStream() throws IOException
    Retrieves the body of the request as binary data using a `ServletInputStream`. Either this method or `getReader()` may be called to read the body, not both.
    Returns:
      a `ServletInputStream` object containing the body of the request
    Throws:
      `IllegalStateException` - if the `getReader()` method has already been called for this request
      `IOException` - if an input or output exception occurred

  - ### getParameter

    String getParameter(String name)
    Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

    You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use `getParameterValues(java.lang.String)`.

    If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by `getParameterValues`.

    If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via `getInputStream()` or `getReader()` can interfere with the execution of this method.

    If not already parsed, calling this method will trigger the parsing of the query string, POSTed form data where the request body has content type is `application/x-www-form-urlencoded` and POSTed form data where the request body has content-type `multipart/form-data` and the Servlet is configured with a `MultipartConfig` annotation or a `multipart-config` element in the deployment descriptor.

    Parameters:
      `name` - a `String` specifying the name of the parameter
    Returns:
      a `String` representing the single value of the parameter
    Throws:
      `IllegalStateException` - if parameter parsing is triggered and a problem is encountered parsing the parameters including, but not limited to: invalid percent (%nn) encoding; invalid byte sequence for the specified character set; I/O errors reading the request body; and triggering a container defined limit related to parameter parsing. Containers may provide container specific options to handle some or all of these errors in an alternative manner that may include not throwing an exception.
    See Also:
      - `getParameterValues(java.lang.String)`

  - ### getParameterNames

    Enumeration<String> getParameterNames()
    Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request. If the request has no parameters, the method returns an empty `Enumeration`.

    If not already parsed, calling this method will trigger the parsing of the query string, POSTed form data where the request body has content type is `application/x-www-form-urlencoded` and POSTed form data where the request body has content-type `multipart/form-data` and the Servlet is configured with a `MultipartConfig` annotation or a `multipart-config` element in the deployment descriptor.

    Returns:
      an `Enumeration` of `String` objects, each `String` containing the name of a request parameter; or an empty `Enumeration` if the request has no parameters
    Throws:
      `IllegalStateException` - if parameter parsing is triggered and a problem is encountered parsing the parameters including, but not limited to: invalid percent (%nn) encoding; invalid byte sequence for the specified character set; I/O errors reading the request body; and triggering a container defined limit related to parameter parsing. Containers may provide container specific options to handle some or all of these errors in an alternative manner that may include not throwing an exception.

  - ### getParameterValues

    String[] getParameterValues(String name)
    Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.

    If the parameter has a single value, the array has a length of 1.

    If not already parsed, calling this method will trigger the parsing of the query string, POSTed form data where the request body has content type is `application/x-www-form-urlencoded` and POSTed form data where the request body has content-type `multipart/form-data` and the Servlet is configured with a `MultipartConfig` annotation or a `multipart-config` element in the deployment descriptor.

    Parameters:
      `name` - a `String` containing the name of the parameter whose value is requested
    Returns:
      an array of `String` objects containing the parameter's values
    Throws:
      `IllegalStateException` - if parameter parsing is triggered and a problem is encountered parsing the parameters including, but not limited to: invalid percent (%nn) encoding; invalid byte sequence for the specified character set; I/O errors reading the request body; and triggering a container defined limit related to parameter parsing. Containers may provide container specific options to handle some or all of these errors in an alternative manner that may include not throwing an exception.
    See Also:
      - `getParameter(java.lang.String)`

  - ### getParameterMap

    Map<String,String[]> getParameterMap()
    Returns a java.util.Map of the parameters of this request. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

    If not already parsed, calling this method will trigger the parsing of the query string, POSTed form data where the request body has content type is `application/x-www-form-urlencoded` and POSTed form data where the request body has content-type `multipart/form-data` and the Servlet is configured with a `MultipartConfig` annotation or a `multipart-config` element in the deployment descriptor.

    Returns:
      an immutable java.util.Map containing parameter names as keys and parameter values as map values. The keys in the parameter map are of type String. The values in the parameter map are of type String array.
    Throws:
      `IllegalStateException` - if parameter parsing is triggered and a problem is encountered parsing the parameters including, but not limited to: invalid percent (%nn) encoding; invalid byte sequence for the specified character set; I/O errors reading the request body; and triggering a container defined limit related to parameter parsing. Containers may provide container specific options to handle some or all of these errors in an alternative manner that may include not throwing an exception.

  - ### getProtocol

    String getProtocol()
    Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1. For HTTP servlets, the value returned is the same as the value of the CGI variable `SERVER_PROTOCOL`.
    Returns:
      a `String` containing the protocol name and version number

  - ### getScheme

    String getScheme()
    Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`. Different schemes have different rules for constructing URLs, as noted in RFC 1738.
    Returns:
      a `String` containing the name of the scheme used to make this request

  - ### getServerName

    String getServerName()
    Returns the host name of the server to which the request was sent. It is the value of the part before ":" in the `Host` header value, if any, or the resolved server name, or the server IP address.
    Returns:
      a `String` containing the name of the server

  - ### getServerPort

    int getServerPort()
    Returns the port number to which the request was sent. It is the value of the part after ":" in the `Host` header value, if any, or the server port where the client connection was accepted on.
    Returns:
      an integer specifying the port number

  - ### getReader

    BufferedReader getReader() throws IOException
    Retrieves the body of the request as character data using a `BufferedReader`. The reader translates the character data according to the character encoding used on the body. Either this method or `getInputStream()` may be called to read the body, not both.
    Returns:
      a `BufferedReader` containing the body of the request
    Throws:
      `UnsupportedEncodingException` - if the character set encoding used is not supported and the text cannot be decoded
      `IllegalStateException` - if `getInputStream()` method has been called on this request
      `IOException` - if an input or output exception occurred
    See Also:
      - `getInputStream()`

  - ### getRemoteAddr

    String getRemoteAddr()
    Returns the Internet Protocol (IP) address of the client or last proxy that sent the request. For HTTP servlets, same as the value of the CGI variable `REMOTE_ADDR`.
    Returns:
      a `String` containing the IP address of the client that sent the request

  - ### getRemoteHost

    String getRemoteHost()
    Returns the fully qualified name of the client or the last proxy that sent the request. If the engine cannot or chooses not to resolve the hostname (to improve performance), this method returns the dotted-string form of the IP address. For HTTP servlets, same as the value of the CGI variable `REMOTE_HOST`.
    Returns:
      a `String` containing the fully qualified name of the client

  - ### setAttribute

    void setAttribute(String name, Object o)
    Stores an attribute in this request. Attributes are reset between requests. This method is most often used in conjunction with `RequestDispatcher`.

    Attribute names should follow the same conventions as package names. Names beginning with `jakarta.*` are reserved for use by the Jakarta EE platform.

    If the object passed in is null, the effect is the same as calling `removeAttribute(java.lang.String)`.
    It is warned that when the request is dispatched from the servlet resides in a different web application by `RequestDispatcher`, the object set by this method may not be correctly retrieved in the caller servlet.

    Parameters:
      `name` - a `String` specifying the name of the attribute
      `o` - the `Object` to be stored

  - ### removeAttribute

    void removeAttribute(String name)
    Removes an attribute from this request. This method is not generally needed as attributes only persist as long as the request is being handled.

    Attribute names should follow the same conventions as package names. Names beginning with `jakarta.*` are reserved for use by the Jakarta EE platform.

    Parameters:
      `name` - a `String` specifying the name of the attribute to remove

  - ### getLocale

    Locale getLocale()
    Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns the default locale for the server.
    Returns:
      the preferred `Locale` for the client

  - ### getLocales

    Enumeration<Locale> getLocales()
    Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns an `Enumeration` containing one `Locale`, the default locale for the server.
    Returns:
      an `Enumeration` of preferred `Locale` objects for the client

  - ### isSecure

    boolean isSecure()
    Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
    Returns:
      a boolean indicating if the request was made using a secure channel

  - ### getRequestDispatcher

    RequestDispatcher getRequestDispatcher(String path)
    Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

    The pathname specified may be relative, although it cannot extend outside the current servlet context. If the path begins with a "/" it is interpreted as relative to the current context root. This method returns `null` if the servlet container cannot return a `RequestDispatcher`.

    The difference between this method and `ServletContext.getRequestDispatcher(java.lang.String)` is that this method can take a relative path.

    Parameters:
      `path` - a `String` specifying the pathname to the resource. If it is relative, it must be relative against the current servlet.
    Returns:
      a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the servlet container cannot return a `RequestDispatcher`
    See Also:
      - `RequestDispatcher`
      - `ServletContext.getRequestDispatcher(java.lang.String)`

  - ### getRemotePort

    int getRemotePort()
    Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.
    Returns:
      an integer specifying the port number
    Since:
      Servlet 2.4

  - ### getLocalName

    String getLocalName()
    Returns the host name of the Internet Protocol (IP) interface on which the request was received.
    Returns:
      a `String` containing the host name of the IP on which the request was received.
    Since:
      Servlet 2.4

  - ### getLocalAddr

    String getLocalAddr()
    Returns the Internet Protocol (IP) address of the interface on which the request was received.
    Returns:
      a `String` containing the IP address on which the request was received.
    Since:
      Servlet 2.4

  - ### getLocalPort

    int getLocalPort()
    Returns the Internet Protocol (IP) port number of the interface on which the request was received.
    Returns:
      an integer specifying the port number
    Since:
      Servlet 2.4

  - ### getServletContext

    ServletContext getServletContext()
    Returns:
      TODO
    Since:
      Servlet 3.0 TODO SERVLET3 - Add comments

  - ### startAsync

    AsyncContext startAsync() throws IllegalStateException
    Returns:
      TODO
    Throws:
      `IllegalStateException` - If async is not supported for this request
    Since:
      Servlet 3.0 TODO SERVLET3 - Add comments

  - ### startAsync

    AsyncContext startAsync(ServletRequest servletRequest, ServletResponse servletResponse) throws IllegalStateException
    Parameters:
      `servletRequest` - The ServletRequest with which to initialise the asynchronous context
      `servletResponse` - The ServletResponse with which to initialise the asynchronous context
    Returns:
      TODO
    Throws:
      `IllegalStateException` - If async is not supported for this request
    Since:
      Servlet 3.0 TODO SERVLET3 - Add comments

  - ### isAsyncStarted

    boolean isAsyncStarted()
    Returns:
      TODO
    Since:
      Servlet 3.0 TODO SERVLET3 - Add comments

  - ### isAsyncSupported

    boolean isAsyncSupported()
    Returns:
      TODO
    Since:
      Servlet 3.0 TODO SERVLET3 - Add comments

  - ### getAsyncContext

    AsyncContext getAsyncContext()
    Get the current AsyncContext.
    Returns:
      The current AsyncContext
    Throws:
      `IllegalStateException` - if the request is not in asynchronous mode (i.e. @link #isAsyncStarted() is `false`)
    Since:
      Servlet 3.0

  - ### getDispatcherType

    DispatcherType getDispatcherType()
    Returns:
      TODO
    Since:
      Servlet 3.0 TODO SERVLET3 - Add comments

  - ### getRequestId

    String getRequestId()
    Obtain a unique (within the lifetime of the Servlet container) identifier string for this request.

    There is no defined format for this string. The format is implementation dependent.

    Returns:
      A unique identifier for the request
    Since:
      Servlet 6.0

  - ### getProtocolRequestId

    String getProtocolRequestId()
    Obtain the request identifier for this request as defined by the protocol in use. Note that some protocols do not define such an identifier.

    Examples of protocol provided request identifiers include:

    HTTP 1.x
      None, so the empty string should be returned
    HTTP 2
      The stream identifier
    HTTP 3
      The stream identifier
    AJP
      None, so the empty string should be returned
    Returns:
      The request identifier if one is defined, otherwise an empty string
    Since:
      Servlet 6.0

  - ### getServletConnection

    ServletConnection getServletConnection()
    Obtain details of the network connection to the Servlet container that is being used by this request. The information presented may differ from information presented elsewhere in the Servlet API as raw information is presented without adjustments for, example, use of reverse proxies that may be applied elsewhere in the Servlet API.
    Returns:
      The network connection details.
    Since:
      Servlet 6.0